// C Source File
// Created 2/7/2001; 10:24:11 PM

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

short _ti89;                  // Produce .89Z File

typedef struct
{
	int x;
	int y;
} coord;

coord vert1 = {10,95};
coord vert2 = {80,5};
coord vert3 = {150,95};

coord midpoint(coord a,coord b)
{
	coord temp;
	temp.x = (a.x + b.x) / 2; 
	temp.y = (a.y + b.y) / 2;
	return temp;
}

void sierp(long iterations)
{
   coord current,midpt;
   int i,randvert;
   current.x = 50;
   current.y = 80;
   for(i = 0; i < iterations; i++)
   {
      randvert = random(3);
      switch(randvert)
      {
         case 0: midpt = midpoint(vert1,current); 
            break;
         case 1: midpt = midpoint(vert2,current); 
            break;
         case 2: midpt = midpoint(vert3,current); 
            break;
      }
      DrawPix(midpt.x,midpt.y,A_NORMAL);
      current = midpt;
   }
}
// Main Function
void _main(void)
{
	LCD_BUFFER buffer;
	LCD_save (buffer);
	randomize();
	clrscr ();
  sierp(10000);
	ngetchx ();
	LCD_restore (buffer);

	return;
}
